//---------------------------------------------------------------------------
#ifndef IvoryBitmapH
#define IvoryBitmapH

//---------------------------------------------------------------------------
class IVORY_package TIvoryBitmap : public TComponent
{
private:
	HBITMAP FHandle;
   String FFileName;
   String FResourceName;
   HANDLE FDllHandle;
   String FDllName;
   int FWidth;
   int FHeight;
   unsigned char* FBits;
   int FWidthBytes;

   Classes::TNotifyEvent FOnChange;
protected:
	void __fastcall SetHandle(HBITMAP handle);
   void __fastcall SetFileName(const String filename);
   void __fastcall LoadBitmapFromFile();
   void __fastcall SetResourceName(const String resname);
   void __fastcall LoadBitmapFromResource();
   void __fastcall SetDllHandle(HANDLE dllhandle);
   void __fastcall SetDllName(const String dllname);
   void* __fastcall GetScanLine(int Row) const;
public:
	__fastcall TIvoryBitmap(Classes::TComponent* AOwner);
   __fastcall ~TIvoryBitmap();
   inline void __fastcall LoadFromFile(const String filename) { FileName = filename; }
   inline void __fastcall LoadFromDll(const String resname, const String dllname) { DllName = dllname; ResourceName = resname; }
   void __fastcall CreateEmpty(int width, int height);
//   void __fastcall SetPixels(const unsigned char* pixels, int N_pixels);
//   void __fastcall GetPixels(unsigned char* pixels, int N_pixels) const;

   __property HBITMAP Handle = { read=FHandle, write=SetHandle };
   __property HANDLE DllHandle = { read=FDllHandle, write=SetDllHandle };
   __property int Width = { read=FWidth };
   __property int Height = { read=FHeight };
   __property void* ScanLine[int Row] = { read=GetScanLine };
__published:
	__property String FileName = { read=FFileName, write=SetFileName };
   __property String ResourceName = { read=FResourceName, write=SetResourceName };
   __property String DllName = { read=FDllName, write=SetDllName };

   __property Classes::TNotifyEvent OnChange = { read=FOnChange, write=FOnChange, default=NULL };
};
//---------------------------------------------------------------------------
#endif
