//---------------------------------------------------------------------------
#ifndef IvoryErrorH
#define IvoryErrorH

#include <ddraw.h>
//---------------------------------------------------------------------------
enum TIvoryErrorCode { iecUnknownError, iecDirectDrawError, iecDirectDraw, iecCreateSurfaceError, iecPaintSurfaceError, iecSourceSurfaceError, iecCanvasError, iecPaletteError };

class EIvoryError : public Exception
{
private:
	HRESULT FDDResult;
   TIvoryErrorCode FIvoryError;
   String FUserMessage;
   String FPlace;
protected:
	static String __fastcall GetDDErrorMsg(HRESULT result);
   static String __fastcall GetIvoryErrorMsg(TIvoryErrorCode error);
public:
	__fastcall EIvoryError(const String msg, const String place = "") : Exception("User Error in " + place + " :\n" + msg), FDDResult(-1), FIvoryError(iecUnknownError), FPlace(place), FUserMessage(msg) { }
	__fastcall EIvoryError(HRESULT result, const String place) : Exception("Direct Draw Error in " + place + " :\n" + GetDDErrorMsg(result)), FDDResult(result), FIvoryError(iecDirectDrawError), FPlace(place), FUserMessage("") { }
	__fastcall EIvoryError(TIvoryErrorCode err, const String place) : Exception("Ivory Draw Error in " + place + " :\n" + GetIvoryErrorMsg(err)), FDDResult(-1), FIvoryError(err), FPlace(place), FUserMessage("") { }

   __property HRESULT DDResult = { read=FDDResult };
   __property TIvoryErrorCode IvoryError = { read=FIvoryError };
   __property String UserMessage = { read=FUserMessage };
};
//---------------------------------------------------------------------------
#endif
